extends TextureButton

const MUTE_NORMAL = preload("res://user_interface/tool_bar/icons/mute.png")
const MUTE_HOVER = preload("res://user_interface/tool_bar/icons/mute_hover.png")
const MUTE_PRESSED = preload("res://user_interface/tool_bar/icons/mute_pressed.png")

const UNMUTE_NORMAL = preload("res://user_interface/tool_bar/icons/unmute.png")
const UNMUTE_HOVER = preload("res://user_interface/tool_bar/icons/unmute_hover.png")
const UNMUTE_PRESSED = preload("res://user_interface/tool_bar/icons/unmute_pressed.png")

onready var mute_dash = get_node("MuteDash")


func _ready():
# warning-ignore:return_value_discarded
	Call.connect("mute_toggled", self, "_on_mute_toggled")
# warning-ignore:return_value_discarded
	Users.connect("switched", self, "_on_user_switched")


func _change_icon_to_mute():
	mute_dash.visible = false
	texture_normal = MUTE_NORMAL
	texture_hover = MUTE_HOVER
	texture_pressed = MUTE_PRESSED


func _change_icon_to_unmute():
	mute_dash.visible = true
	texture_normal = UNMUTE_NORMAL
	if get_global_rect().has_point(get_global_mouse_position()):
		texture_hover = UNMUTE_NORMAL
	else:
		texture_hover = UNMUTE_HOVER
	texture_pressed = UNMUTE_PRESSED


func _on_pressed():
	if Users.get_primary().is_current():
		Call.toggle_mute()


func _on_mute_toggled(value):
	if value:
		_change_icon_to_unmute()
	else:
		_change_icon_to_mute()


func _on_mouse_exited():
	if Call.is_muted or Users.get_helper().is_current():
		texture_hover = UNMUTE_HOVER


func _on_user_switched():
	if Users.get_helper().is_current():
		_change_icon_to_unmute()
	else:
		_on_mute_toggled(Call.is_muted)
